<?php
/* forum plugin (page program version)
	author: team1/3
	name : forum
	released: 2014/10/04
	coyright(c) SpiQe Software,team1/3 All Rights Reserved.
*/

	if (!isset($config)) { die(); }

	if (!check_rights()) {
		@session_set_cookie_params(0, $config['site']['cookie_path']);
		@session_start();
	}

	draw();
	
	$params['rendering'] = false;

function draw()
{
	global $html,$params,$database,$ut,$plugin_ar;
	
	$plugin_ar[ EMBED_ID ] = array(
		  'selector' => "embed"
		, 'php' => ".ez_login/embed"
		, 'onbefore_modified' =>'forum_embed_onbefore_modified'
	);

	$page_ar = &$params['page'];
	$p_page = $page_ar['id'];
	provide_onethird_object();
	
$html['css']['forum-draw'] = <<<EOT
	<style>
	.onethird-forum-panel {
		padding:10px;
		border: 1px solid #c0c0c0;
		margin-bottom:20px;
		position: relative;
	}
	.onethird-forum-panel .avatar {
		font-size:30px;
	}
	.onethird-forum-panel .del_hnd {
		position: absolute;
		right:5px;
		top:5px;
	}
	.onethird-forum-panel .avatar img {
		vertical-align: middle;
		height:48px;
		min-width:48px;
	}
	.onethird-forum .table {
		display:table;
	}
	.onethird-forum .left-unit {
		display:inline-block;
		min-width:100px;
		border: 1px solid #c0c0c0;
	}
	.onethird-forum .mid-unit {
		display:table-cell;
		vertical-align: top;
		width:100%;
		padding:0 5px;
	}
	.onethird-forum .image-panel {
		display:inline-block;
		width:300px;
		height:190px;
		overflow: hidden;
	}
	.onethird-forum .image-panel img {
		width:100%;
	}
	.onethird-forum .item-panel {
		position: relative;
		display:table;
		width: 100%;
	    margin: 5px 0;
	}
	.onethird-forum .item-panel div.left {
		display:inline-block;
		min-width:150px;
		background-color: rgb(212, 211, 211);
		padding:2px 7px;
		min-height:30px;
		margin-right: 6px;
		height: 100%;
	}
	#_tryitEditor_contents .onethird-forum .item-panel div.left {
		display:block;
	}
	.onethird-forum .item-panel div.right {
		display:table-cell;
		vertical-align: top;
		width:100%;
		padding:2px 7px;
		background-color: rgba(220, 220, 220, 0.5);
	}
	.onethird-forum .top-unit , .onethird-forum .bottom-unit{
		width:100%;
		margin: 5px 0;
	}
	.onethird-forum .item {
		min-width:100px;
		display: inline-block;
		min-height:20px;
	}
	.onethird-forum .item[data-type=img] {
		width:100%;
		min-height:150px;
	}
	.onethird-forum div[data-type=edit] {
		min-height:8em;
	}
	.onethird-forum .rem {
		font-size: 92%;
		opacity: 0.9;
		font-style: italic;
	}
	.onethird-forum-list-panel .tag {
		background-color: #444343;
		color: #fff;
		display: inline-block;
		padding: 0 11px;
		border-radius: 19px;
		font-size: 75%;
		line-height: 167%;
    }
	.onethird-forum-list-panel .status {
		color: #0d1115;
	}
	.onethird-forum-list-panel .open {
		color: #fb4949;
		font-weight:bold;
	}
	.forum-alert {
		background-color: #f5c3c3;
		padding: 20px;
	}
	</style>
EOT;

	//if (!function_exists('ezlogin_renderer')) {
	//	$html['article'][] = "<h2 style='color:red'>ERROR:ezlogin が読み込まれていません<h2>";
	//}
	
	if (PAGE_FOLDER_ID != $page_ar['type'] && $page_ar['link'] && $page_ar['block_type']==10) {
		if (!empty($page_ar['meta']['ezlogin_draft'])) {
			if (!empty($page_ar['meta']['ezlogin_id']) && !empty($_SESSION['ezlogin_id']) && $page_ar['meta']['ezlogin_id'] == $_SESSION['ezlogin_id']) {
			} else {
				exit_proc(405);
			}
		}
		if (isset($_GET['mode']) && $_GET['mode'] == 'edit') {
			// 編集
			provide_edit_module();
			unset($params['breadcrumb']);
			snippet_breadcrumb($p_page, 'Page Edit');
			$buff = page_edit_renderer($page_ar);
			$html['article'][] = frame_renderer($buff);
			return;
		}
		$format0 = get_def_format0($page_ar);
		$format1 = get_def_format1($page_ar);
		if (read_pagedata($page_ar['link'], $tmp)) {
			if (isset($tmp['meta']['format0'])) {
				$format0 = $tmp['meta']['format0'];
			}
			if (isset($tmp['meta']['format1'])) {
				$format1 = $tmp['meta']['format1'];
			}
		}
$tmp = <<<EOT
		<h1>{$page_ar['title']}</h1>
EOT;
		if (check_forum_draft($page_ar)) {
$tmp .= <<<EOT
			<p class='forum-alert'>このページはまだ公開されていません、公開するには状態を変更してください
			</p>
EOT;
		}
		$tmp = frame_renderer($tmp.my_body_renderer($page_ar,$format0));
		$html['article'][] = my_custompage_renderer($page_ar['id'],$tmp,$format1);
		$html['article'][] = frame_renderer(forum_innerpage($page_ar));
		return;
	}


	if (isset($_GET['mode']) && $_GET['mode'] == 'edit') {
		// 編集
		provide_edit_module();
		unset($params['breadcrumb']);
		snippet_breadcrumb($p_page, 'Page Edit');
		$buff = page_edit_renderer($page_ar);
		$html['article'][] = frame_renderer($buff);
		return;

	} else if (isset($_GET['mode']) && ($_GET['mode'] == 'format0' || $_GET['mode'] == 'format1')) {
		// format編集
		$params['hook']['before_modified'][] = 'forum_onbefore_modified';
		provide_edit_module();
		unset($params['breadcrumb']);
		snippet_breadcrumb($p_page, 'Format Edit');
		snippet_forum_format_js_css();

		$params['hide-editmenu'] = true;
$params['add-editmenu'][] = <<<EOT
		<input type='button' onclick='ot.save_editdata(1)' class='onethird-button mini'  value='save' />
		<input type='button' onclick='ot.open_uploader({select:function(obj){ot.editor.insertimg(obj)}})' class='onethird-button mini' value='image' />
EOT;
		if ($_GET['mode'] == 'format1') {
			if (isset($page_ar['meta']['format1'])) {
				$page_ar['contents'] = $page_ar['meta']['format1'];
			} else {
				$page_ar['contents'] = get_def_format1($page_ar);
			}
		} else {
			if (isset($page_ar['meta']['format0'])) {
				$page_ar['contents'] = $page_ar['meta']['format0'];
			} else {
				$page_ar['contents'] = get_def_format0($page_ar);
			}
		}
		$buff = page_edit_renderer($page_ar);
		$html['article'][] = frame_renderer($buff);

	} else {
		// 通常表示
		$params['add-blockmenu'][] = "<a href='{$ut->link($page_ar['id'],'&:mode=format0')}' class='onethird-button mini'>format0</a>";
		$params['add-blockmenu'][] = "<a href='{$ut->link($page_ar['id'],'&:mode=format1')}' class='onethird-button mini'>format1</a>";
		snippet_breadcrumb($page_ar['link'], $page_ar['title']);
		$buff = frame_renderer(body_renderer($page_ar).forum_folder($page_ar));
		$html['article'][] =  custompage_renderer($page_ar['id'],$buff);
	}

	// css style
	if (!isset($html['head']['plugin-page-folder'])) {
$html['head']['plugin-page-folder'] = <<<EOT
		<style>
		</style>
EOT;
	}

}

function forum_onbefore_modified( &$new_ar )
{
	global $params,$config,$ut;

	if (isset($_GET['mode']) && ($_GET['mode'] == 'format1' || $_GET['mode'] == 'format0')) {
	} else {
		return;
	}
	
	//フォーマットの保存処理
	if ($_GET['mode'] == 'format1') {
		$new_ar['meta']['format1'] = $new_ar['contents'];
	} else {
		$new_ar['meta']['format0'] = $new_ar['contents'];
	}
	$new_ar['metadata'] = serialize64($new_ar['meta']);
	unset($new_ar['meta']);
	unset($new_ar['contents']);
	if (!mod_data_items($new_ar)) {
		if (isset($_POST['ajax'])) {
			echo( json_encode($r) );
			exit();
		}
		exit_proc(400, 'Save-Error');

	} else {

		if ($new_ar['type'] >= 10) {
			event_plugin_page('onmodified', $new_ar);
		}
		
		if (isset($r['url'])) {
			header("Location: {$r['url']}");
		
		} else {
			if ($new_ar['block_type'] == 5) {
				header("Location: {$ut->link($new_ar['link'])}");
			} else {
				header("Location: {$ut->link($new_ar['id'])}");
			}
		}
		
		exit();
	}
}
/*
function forum_folder_menu( &$page_ar )
{
	global $params, $ut, $html, $database, $plugin_ar;

	$id = $page_ar['id'];
	$parent_page = $page_ar['id'];		//自ページが親ページ

	
	if (check_rights('edit')) {
		if (isset($_POST['ajax']) && $_POST['ajax'] == 'plugin_forum_make_page')  {
			$r = array();
			$r['link'] = (int)$_POST['page'];
			$r['result'] = false;
			
			if (empty($_POST['type'])) {
				echo( json_encode($r) );
				exit();
			}
			$r['type'] = (int)($_POST['type']);
			if ($r['type'] == PAGE_FOLDER_ID) {
				$r['title'] = 'Folder'.time();
				$r['block_type'] = 10;
				if (isset($page_ar['meta']['format0'])) {
					$r['meta']['format0'] = $page_ar['meta']['format0'];
				} else {
					$r['meta']['format0'] = get_def_format0($page_ar);
				}
				if (isset($page_ar['meta']['format1'])) {
					$r['meta']['format1'] = $page_ar['meta']['format1'];
				} else {
					$r['meta']['format1'] = get_def_format1($page_ar);
				}
				$r['meta']['template_ar']['php'] = ".".basename(__FILE__);
				$r['meta']['lwr_template_ar']['php'] = ".".basename(__FILE__);
			} else {
				$r['title'] = 'DATA-'.substr(time(),-4);
				$r['block_type'] = 10;
				$r['meta']['template_ar']['php'] = ".".basename(__FILE__);
			}
			create_page( $r );
			
			if ($r['type'] == PAGE_FOLDER_ID && isset($r['open_url'])) {
				unset($r['open_url']);
			}
			echo( json_encode($r) );
			exit();
		}
		if (!isset($html['meta']['plugin_forum_make_page'])) {
$html['meta']['plugin_forum_make_page'] = <<<EOT
			<script>
			ot.plugin_forum_make_page = function (link,type) {
				var opt = "ajax=plugin_forum_make_page";
				opt += "&type="+type+"&page="+link;
				ot.ajax({
					type: "POST"
					, url: '{$_SERVER['REQUEST_URI']}'
					, data: opt
					, dataType:'json'
					, success: function(data){
						if ( data && data['result'] ) {
							if ( data['open_url'] ) {
								location.href = data['open_url'];
							} else {
								location.reload(true);
							}
						} else {
							alert('Failure to create a page.');
						}
					}
				});
			};
			</script>
EOT;
		}
	}

$tmp = <<<EOT
	<a href='{$ut->link($page_ar['id'],'&:mode=export')}' class='onethird-button mini'>CSV export</a>
	<a href='javascript:void(ot.page_forum_setting())' class='onethird-button mini'>Setting</a>
EOT;
	if ($page_ar['meta']['page_forum_parent'] == $page_ar['id']) {
$tmp .= <<<EOT
		<a href='{$ut->link($page_ar['id'],'&:mode=format')}' class='onethird-button mini'>format</a>
EOT;
	}
	$params['add-blockmenu'][] = $tmp;

	// 設定
	if (check_rights('edit')) {
		snippet_std_setting("Setting","page_forum_setting");
		if (isset($_POST['ajax']) && $_POST['ajax'] == "page_forum_setting")  {
			$r = array();
			$r['result'] = true;
			$r['id'] = $p_id = $params['page']['id'];
			$r['meta'] = $params['page']['meta'];

			if (empty($r['meta']['page_forum_writer'])) {
				$r['meta']['page_forum_writer'] = 'forum_folder';
			}
			$writer_ar = array('forum_folder'=>'forum_folder','gallery_folder'=>'gallery_folder');
			if (!empty($params['page_forum_writer'])) {
				$writer_ar = $params['page_forum_writer'];
			}
$r['html'] = <<<EOT
			<table>
				<tr>
					<td >Writer</td>
					<td>
						{$ut->input(array(
							'type'=>'select'
							, 'data-input'=>'page_forum_writer'
							, 'value'=>$r['meta']['page_forum_writer']
							, 'option'=>$writer_ar
						))}
					</td>
				</tr>
				<tr>
					<td >Parent page</td>
					<td>
						<input type='text' value='{$ut->safe_echo($page_ar['meta']['page_forum_parent'])}' data-input='page_forum_parent' />
					</td>
				</tr>
				<tr>
					<td >Item count</td>
					<td>
						<input type='text' value='{$ut->safe_echo($page_ar['meta']['page_forum_page_size'])}'  data-input='page_forum_page_size' />
					</td>
				</tr>
				<tr>
					<td style='vertical-align: top;'>Option</td>
					<td>
						<ul class="inputs-list">
							<li><label>
								<input type='checkbox' data-input='page_forum_allow_post' 
									{$ut->check(!empty($r['meta']['page_forum_allow_post']),'checked')}/> 
									Allow All Users to Submit Posts
								</label>
							</li>
							<li><label>
								<input type='checkbox' data-input='page_forum_random' 
									{$ut->check(!empty($r['meta']['page_forum_random']),'checked')}/> 
									Random list
								</label>
							</li>
						<ul>
					</td>
				</tr>
			</table>
EOT;
			echo(json_encode($r));
			exit();
		}

		if (check_rights('edit') && isset($_POST['ajax']) && $_POST['ajax'] == 'save_page_forum_setting')  {

			$r = array();
			$r['result'] = false;
			$r['id'] = $params['page']['id'];
			$r['meta'] = $params['page']['meta'];

			function _option_save_plugin_page_forum_setting($a, &$page_ar) {
				if (isset($_POST[$a])) {
					$page_ar['meta'][$a] = sanitize_str($_POST[$a]);
				} else {
					if (isset($page_ar['meta'][$a])) { unset($page_ar['meta'][$a]); }
				}
			}
			_option_save_plugin_page_forum_setting('page_forum_writer', $r);

			if (isset($_POST['page_forum_allow_post'])) {
				$r['meta']['page_forum_allow_post'] = true;
			} else {
				$r['meta']['page_forum_allow_post'] = false;
			}
			if (isset($_POST['page_forum_parent'])) {
				$r['meta']['page_forum_parent'] = sanitize_asc($_POST['page_forum_parent']);
			} else {
				unset($r['meta']['page_forum_parent']);
			}
			if (isset($_POST['page_forum_random'])) {
				$r['meta']['page_forum_random'] = true;
			} else {
				unset($r['meta']['page_forum_random']);
			}
			if (isset($_POST['page_forum_page_size'])) {
				$r['meta']['page_forum_page_size'] = (int)$_POST['page_forum_page_size'];
			} else {
				unset($r['meta']['page_forum_page_size']);
			}
			$r['metadata'] = serialize64($r['meta']);
			if (mod_data_items($r)) {
				$r['result'] = true;
			}

			echo(json_encode($r));
			exit();
		}
	}
}
*/
function forum_folder( &$page_ar )
{
	global $database,$params,$html,$plugin_ar,$config,$ut;
	
	if (isset($_POST['ajax']) && $_POST['ajax'] == '*plugin_forum_make_page')  {
		$r = array();
		$r['link'] = (int)$_POST['page'];
		$r['result'] = false;
		if (empty($_POST['type'])) {
			echo( json_encode($r) );
			exit();
		}
		$r['type'] = (int)($_POST['type']);
		if ($r['type'] == PAGE_FOLDER_ID) {
			if (check_rights('edit')) {
				$r['title'] = 'Folder'.time();
				$r['block_type'] = 10;
				if (isset($page_ar['meta']['format0'])) {
					$r['meta']['format0'] = $page_ar['meta']['format0'];
				} else {
					$r['meta']['format0'] = get_def_format0($page_ar);
				}
				if (isset($page_ar['meta']['format1'])) {
					$r['meta']['format1'] = $page_ar['meta']['format1'];
				} else {
					$r['meta']['format1'] = get_def_format1($page_ar);
				}
				$r['meta']['template_ar']['php'] = ".".basename(__FILE__);
				$r['meta']['lwr_template_ar']['php'] = ".".basename(__FILE__);
				create_page( $r );
			}
		} else {
			if (check_and_set_forum_rights()) {
				$r['title'] = 'FORUM - '.substr(time(),-4);
				$r['block_type'] = 10;
				$r['user'] = 0;
				$r['meta']['template_ar']['php'] = ".".basename(__FILE__);
				if (!empty($_SESSION['ezlogin_id'])) {
					$r['meta']['ezlogin_id'] = $_SESSION['ezlogin_id'];
					$r['meta']['ezlogin_draft'] = true;
					$r['mode'] = 1;
				}
				create_page( $r );
			}
		}
		if ($r['type'] == PAGE_FOLDER_ID && isset($r['open_url'])) {
			unset($r['open_url']);
		}
		echo( json_encode($r) );
		exit();
	}
	if (!isset($html['meta']['plugin_forum_make_page'])) {
$html['meta']['plugin_forum_make_page'] = <<<EOT
		<script>
		ot.plugin_forum_make_page = function (link,type) {
			var opt = "ajax=*plugin_forum_make_page";
			opt += "&type="+type+"&page="+link;
			ot.ajax({
				type: "POST"
				, url: '{$_SERVER['REQUEST_URI']}'
				, data: opt
				, dataType:'json'
				, success: function(data){
					if ( data && data['result'] ) {
						if ( data['open_url'] ) {
							location.href = data['open_url'];
						} else {
							location.reload(true);
						}
					} else {
						alert('Failure to create a page.');
					}
				}
			});
		};
		</script>
EOT;
	}

	$buff = '';

	$p_page = $page_ar['id'];
	$type = $page_ar['type'];
	$page_forum_page_size = 80;
	if (!empty($page_ar['meta']['page_forum_page_size'])) {
		$page_forum_page_size = $page_ar['meta']['page_forum_page_size'];
	}

	$option = array();
	$option['total'] = 0;
	$option['offset'] = 0;
	$option['page_size'] = $page_forum_page_size;

	$offset_name = 'offset';
	$option['offset_name'] = $offset_name;
	if (isset($_GET[$offset_name])) {
		$option['offset'] = (int)$_GET[$offset_name];
	}
	if (isset($arg['page_size'])) {
		$option['page_size'] = (int)$arg['page_size'];
	}

	$sql[0] = "select count(id) as c from ".DBX."data_items ";
	$sql[1] = array(" where block_type = 10");
	$sql[2] = array(" and type <> ? and link=?  ",PAGE_FOLDER_ID,$p_page);

	if (check_rights()) {
		$sql[3] = array(' and (mode=1 or (mode=0 and user=?)) ',(int)($_SESSION['login_id']));
	} else {
		$sql[3] = array(' and mode=1 ');
	}

	// count
	$ar = $database->sql_select_all($sql);
	if ($ar) {
		$option['total'] = $ar[0]['c'];
	}

	// page
	$sql[0] = "select id,type,metadata,title,mode,user,date,mod_date from ".DBX."data_items ";
	$sql[2] = array(" and type <> ? and link=?",PAGE_FOLDER_ID,$p_page);
	$sql[]  = array(" order by mod_date desc {$ut->limit($option['offset']*$option['page_size'], $option['page_size'])} ");
	
	$ar = $database->sql_select_all($sql);
	if ($ar) {
		foreach ($ar as $v) {
			$m = $v['meta'] = unserialize64($v['metadata']);
			$d = substr($v['mod_date'],0,10);
			$icon = '';
			if (check_forum_draft($v)) {
				if (!check_forum_item_owner($m)) {
					continue;
				}
				$icon = $ut->icon('lock');
			}
			$tag = '';
			if (!empty($m['plugin_embed']['type'])) {
				$tag = "<span class='tag'>{$m['plugin_embed']['type']}</span>";
			}
			$status = '';
			if (!empty($m['plugin_embed']['status'])) {
				$status = $m['plugin_embed']['status'];
				if ($status == 'open') {
					$status = "<span class=' open'>{$status}</span>";
				} else {
					$status = "<span class=' status'>{$status}</span>";
				}
			}
$buff .= <<<EOT
			<p id='forum_{$v['id']}' class='item' >$d $icon $tag <a href='{$ut->link($v['id'])}'>{$v['title']}</a> $status
			</p>
EOT;
		}
	} else {
$buff .= <<<EOT
		<p >登録されていません
		</p>
EOT;
	}
	
	if (check_and_set_forum_rights()) {
$buff .= <<<EOT
		<p class='add-panel'>
			<input type='button' value='新規追加' class='onethird-button mini' onclick='ot.plugin_forum_make_page({$p_page}, 1)' />
		</p>
EOT;
	}

	return "<div class='onethird-forum-list-panel' >".$buff."</div>";
}

function my_custompage_renderer( $p_page, &$body=false, $format )
{
	global $database,$plugin_ar,$params,$ut;
	$buff = '';
	if (!isset($params['page']) || empty($params['page']['meta'])) {
		return;
	}
	if (!isset($params['page']['meta']['renderer'])) {
		return;
	}
	$i = 0;
	$c = count($params['page']['meta']['renderer']);
	foreach ($params['page']['meta']['renderer'] as $k=>$v) {
		++$i;
		if ( $k == $p_page ) {
			$ar = null;
			if ($body) {$buff .= $body;}
		} else if ( is_numeric($k) ) {
			$ar = array();
			read_pagedata( $k, $ar );

		} else {
			$ar = null;
		}
		if ($ar && $params['page']['id'] != $ar['id']) {
			$ar['fstblock'] = false;
			$ar['endblock'] = $i == $c;
			$params['inner_page'] = &$ar;
			if (($tmp = plugin_renderer($ar)) !== false) {
				$buff .= $tmp;
			} else {
				$buff .= frame_renderer(my_body_renderer($ar,$format));
			}
			unset($params['inner_page']);
			$fstblock = false;
		}
	}
	return $buff;
}

function my_body_renderer( &$page_ar,$format )
{
	global $params,$html,$plugin_ar,$config,$ut;
	
	$p_page = $page_ar['id'];
	$type= $page_ar['type'];
	$params['inner_page'] = $page_ar;

	$owner = false;
	if (check_and_set_forum_rights() && check_forum_item_owner($page_ar['meta'])) {
		$owner = true;
	}
	$body = plugin_proc('embed','start');
$body .=  <<<EOT
	<p>
	{$ut->str(get_forum_avatar($page_ar))}
EOT;
		if ($owner) {
			$body .="<a href='javascript:void(ot.forum_remove_page({$page_ar['id']}))' title='delete' class='del_hnd'>{$ut->icon('delete')}</a>";
		}
$body .=  <<<EOT
	</p>
EOT;
	if (empty($params['inner_page']['meta']['plugin_embed']['status']) && $owner == false) {
		return "<div class='onethird-forum-panel'>".$body."<p>writing now ...</p></div>";
	}

	$format = preg_replace_callback("/(<div.*?>).*?(<\\/div>)/u",
		function ($matches) {
			global $params,$ut;
			$page_ar = &$params['inner_page'];
			$x = $matches[0];
			preg_match("/data-type=\"(.*?)\" .*?data-name=\"(.*?)\"/u",$x,$m);
			if (!empty($m[1])) {
				if ($m[1] == 'Title') {
					$m[1] = 'text';
					$m[2] = 'title';
				} else if ($m[1] == 'Date') {
					$m[1] = 'date';
					$m[2] = 'date';
				} else if ($m[1] == 'select' || $m[1] == 'checkbox' || $m[1] == 'radio') {
					$y = explode(',',$m[2]);
					$m[2] = $y[0];
					array_shift($y);
					return plugin_proc('embed',$m[1],$y,"name:{$m[2]}","page:{$page_ar['id']}");
				} else if ($m[1] == 'img') {
					return img_proc(array('page'=>$page_ar['id'],'name'=>$m[2],"first_mess:Add image"));
				}
				if ($m[1] == 'map') {
					if (!isset($_SESSION['onethird-plugin-embed-on']) && !empty($page_ar['meta']['plugin_embed'][$m[2]])) {
						return "<a href='https://maps.google.co.jp/maps?q=".urlencode($page_ar['meta']['plugin_embed'][$m[2]])."' target='_blank' >{$page_ar['meta']['plugin_embed'][$m[2]]}</a>";
					}
					return plugin_proc('embed','text',"name:{$m[2]}","page:{$page_ar['id']}");

				} else if ($m[1] == 'Contents') {
					if (!empty($m[2]) && $m[2] == 'edit') {
						return plugin_proc('embed','edit',"name:contents","page:{$page_ar['id']}");
					}
					$m[1] = 'html';
					$m[2] = 'contents';
					return plugin_proc('embed',$m[1],"name:{$m[2]}","page:{$page_ar['id']}");

				} else if ($m[1] == 'url') {
					if (!isset($_SESSION['onethird-plugin-embed-on']) && !empty($page_ar['meta']['plugin_embed'][$m[2]])) {
						$a = $page_ar['meta']['plugin_embed'][$m[2]];
						$pattern = '/((?:https?|ftp):\/\/[-_.!~*\'()a-zA-Z0-9;\/?:@&=+$,%#]+)/ui';
						$replacement = '<a href="\1">\1</a>';
						$a= preg_replace($pattern,$replacement,$a);

						$pattern =  '/([0-9]{6,9,10,11}|[0-9-]{12,13})/ui';
						$replacement = '<a href="tel:\1">\1</a>';
						$a= preg_replace($pattern,$replacement,$a);
						return $a;
					}
					return plugin_proc('embed','edit',"name:{$m[2]}","page:{$page_ar['id']}");

				} else if ($m[1] == 'Tag') {
					$t = get_tags($params['page']['tag']);
					$tag = implode($t, ',');
					if (!isset($_SESSION['onethird-plugin-embed-on']) || $_SESSION['onethird-plugin-embed-on']!=$page_ar['id']) {
						if ($t && is_array($t)) {
							$x = '';
							foreach ($t as $v) {
								if ($x) {$x.=',';}
								$x .= "<a href='{$ut->link("search?t=$v")}' />$v</a>";
							}
							return $x;
						}
						return $tag;
					}
					$x = plugin_proc('embed','text',"name:tag","page:{$page_ar['id']}");
					if (isset($params['circle']['meta']['taglist']) && $params['circle']['meta']['taglist']) {
$x .=  <<<EOT
						<a href="javascript:void(ot.ctypedb_tag_open_close())" style='position: absolute;top: 0;right: 0;'>{$ut->icon('edit'," width='20' ")}</a>
EOT;
						if (isset($params['circle']['meta']['taglist'])) {
							$ar = trim($params['circle']['meta']['taglist'], ',');
							if ($ar && ($ar = explode(',', $ar))) {
$x .=  <<<EOT
								<div class='ctypedb_tag_open_close' style='display:none;' >
EOT;
									foreach($ar as $v) {
										$x .= "<span style='margin:3px 2px 0 0;border:1px solid #c0c0c0;display:inline-block;padding:2px;cursor:pointer'>$v</span>";
									}
$x .=  <<<EOT
								</div>
EOT;
							}
						}
					}
					return $x;
				}
				$x = plugin_proc('embed',$m[1],"name:{$m[2]}","page:{$page_ar['id']}");
			}
			return $x;
		}
	,$format);

	$body.= $format.plugin_proc('embed','save');

	if (check_rights('owner') && !empty($page_ar['meta']['page_ctypedb_writer']) && $page_ar['meta']['page_ctypedb_writer'] == 'gallery_folder' ) {
$body .= <<<EOT
		<input type='button' value='set thumbnail' onclick='ot.select_thumbnail()' class='onethird-button '/>
EOT;
$html['meta']['get_def_format'] = <<<EOT
	<script>
		\$(function() {
			ot.select_thumbnail = function() {
				opt = {};
				opt.thumb = true;
				opt.title = 'Set Thumbnail';
				opt.resize = "auto,320/240/1";
				opt.select = function(obj){
					ot.set_ogimage(obj,'thumb');
					ot.close_dialog();
				}
				ot.open_uploader(opt);
			};
			\$(function(){
				\$(document).on('click','.ctypedb_tag_open_close span',function(event){
					var o = \$(this).parent();
					var tag = \$('.item-panel .inner[data-name=tag] > input');
					var a = tag.val();
					var x = \$(this);
					var t = x.text();
					if (x.hasClass('sel')) {
						a = (","+a+",").replace(new RegExp(","+t+",", "g"), ',');
					} else {
						a = t+','+a;
					}
					a = a.replace(/,,+/g, ',');
					a = a.replace(/(^,|,\$)/gm, ',');
					a = a.replace(/^[ ,]+|[ ,]+\$/g,'');
					tag.val(a);
					ot.ctypedb_tag_sel();
				});
			});
			ot.ctypedb_tag_sel = function() {
				var str = \$('.item-panel .inner[data-name=tag] > input').val();
				var str = str.replace(/(,| |、|，|　)+/g,',');
				\$('.item-panel .inner[data-name=tag] > input').val(str);
				var ar = str.split(',');
				\$('.ctypedb_tag_open_close span').each(function() {
					var oj = \$(this);
					var s = false;
					var k = oj.text();
					for (var i=0; i<ar.length; ++i) {
						if (k == ar[i]) {s = true;}
					}
					if (s) {
						oj.css('background-color','#c0c0c0').addClass('sel');
					} else {
						oj.css('background-color','#fff').removeClass('sel');
					}
				});
			};
			ot.ctypedb_tag_open_close = function() {
				var obj = \$('.ctypedb_tag_open_close');
				if (obj.css('display')=='none'){
					obj.fadeIn();
					ot.ctypedb_tag_sel();
				} else {
					obj.fadeOut();
				}
			};
		});
	</script>
EOT;
	}
	expand_buff($body);
	return "<div class='onethird-forum-panel'>".$body."</div>";
}

function forum_innerpage( &$page_ar )
{
	global $params,$config,$database,$ut,$html;
	
	if (check_and_set_forum_rights()) {
		if (isset($_POST['ajax']) && $_POST['ajax'] == '*plugin_forum_add_rep')  {
			$r = array();
			$r['link'] = (int)$page_ar['id'];
			$r['block_type'] = 5;
			if (!empty($_SESSION['ezlogin_id'])) {
				$r['meta']['ezlogin_id'] = $_SESSION['ezlogin_id'];
			}
			$r['result'] = create_page( $r );
			echo( json_encode($r) );
			exit();
		}
		if (isset($_POST['ajax']) && $_POST['ajax'] == '*remove_page')  {
			$r = array();
			$r['result'] = false;
			$p_page = (int)$_POST['page'];
			$r['page'] = $p_page;
			$r['block_type'] = 0;
			$m = false;
			$ar = $database->sql_select_all( "select user,block_type,metadata from ".DBX."data_items where id=? ", $p_page );
			if ($ar) {
				$r['block_type'] = $ar[0]['block_type'];
				$m = unserialize64($ar[0]['metadata']);
			}
			if (check_rights('owner')) {
				set_func_rights('remove_pages');		// 編集メンバーでなくてもオーナーだったら消せる
			} else {
				if (!check_func_rights('remove_pages')) {
					if (!$m || empty($m['ezlogin_id']) || $m['ezlogin_id'] != $_SESSION['ezlogin_id']) {
						echo( json_encode($r) );
						exit();
					}
					set_func_rights('remove_pages',false);		// ゲストでも消せる
				}
			}
			$r['parent'] = remove_this_page($p_page);
			if ( $r['parent'] !== false ) {
				$r['parent'] = $ut->link($r['parent']);
				$r['result'] = true;
				if ($r['block_type'] == 5 || (isset($params['page']['id']) && $p_page!=$params['page']['id'])) {
					unset($r['parent']);
				}
			}
			repair_alias();
			echo( json_encode($r) );
			exit();
		}
		if (!isset($html['meta']['plugin_forum_add_rep'])) {
$html['meta']['plugin_forum_add_rep'] = <<<EOT
			<script>
			ot.plugin_forum_add_rep = function (link,type) {
				var opt = "ajax=*plugin_forum_add_rep";
				ot.ajax({
					type: "POST"
					, url: '{$_SERVER['REQUEST_URI']}'
					, data: opt
					, dataType:'json'
					, success: function(data){
						if ( data && data['result'] ) {
							location.reload(true);
						} else {
							alert('Failure to create a page.');
						}
					}
				});
			};
			ot.forum_remove_page = function (page_id) {
				if (!confirm('削除しますか?')) {
					return;
				}
				ot.ajax({
					type: "POST"
					, url: '{$_SERVER['REQUEST_URI']}'
					, data: "ajax=*remove_page&page="+page_id
					, dataType:'json'
					, success: function(data){
						if ( data && data['result'] ) {
							if (data['parent']) {
								location.href=data['parent'];
							} else {
								location.reload(true);
							}
						} else {
							alert('Error');
						}
					}
				});
			};
			</script>
EOT;
		}
	}

	$buff = '';
	if (check_and_set_forum_rights()) {
$buff .= <<<EOT
		<p><input type='button' value='追加する' onclick='ot.plugin_forum_add_rep()' class='onethird-button ' />
EOT;
	}

	
	return $buff;
}

function get_def_format0(&$page_ar)
{
	global $params,$config,$ut,$html;

$def_format = <<<EOT
	<div class="onethird-forum" > 
		<div class='top-unit'> 
			<div class="item-panel"> 
				<div class='left'> 
					件名
				</div>
				<div class='right'> 
					<div class="item" data-type="Title" data-name=""></div>
				</div>
			</div>
			<div class="item-panel"> 
				<div class='left'> 
					日付
				</div>
				<div class='right'> 
					<div >{\$ut->page('date')}</div>
				</div>
			</div>
			<div class="item-panel"> 
				<div class='left'> 
					内容
				</div>
				<div class='right'> 
					<div class="item" data-type="Contents" data-name="edit"></div>
				</div>
			</div>
			<div class="item-panel"> 
				<div class='left'> 
					タグ
				</div>
				<div class='right'> 
					<div class="item" data-type="select" data-name="type,質問,提案,バグ,要望,その他"></div>
				</div>
			</div>
			<div class="item-panel"> 
				<div class='left'> 
					状態
				</div>
				<div class='right'> 
					<div class="item" data-type="select" data-name="status,open,close"></div>
					<p class='rem'>
						- open:未解決, close : 解決
					</p>
				</div>
			</div>
		</div>
	</div>
EOT;
	return $def_format;
}

function get_def_format1(&$page_ar)
{
	global $params,$config,$ut,$html;

$def_format = <<<EOT
	<div class="onethird-forum" > 
		<div class='top-unit'> 
			<div class="item-panel"> 
				<div class='left'> 
					日付
				</div>
				<div class='right'> 
					<div >{\$ut->page('date')}</div>
				</div>
			</div>
			<div class="item-panel"> 
				<div class='left'> 
					内容
				</div>
				<div class='right'> 
					<div class="item" data-type="Contents" data-name="edit"></div>
				</div>
			</div>
			<div class="item-panel"> 
				<div class='left'> 
					状態
				</div>
				<div class='right'> 
					<div class="item" data-type="select" data-name="status,open,close,pending,check"></div>
					<p class='rem'>
						- open:対策中, close : 対策済, pending : 保留, check : 確認中
					</p>
				</div>
			</div>
		</div>
	</div>
EOT;
	return $def_format;
}

function snippet_forum_format_js_css()
{
	global $html,$ut,$params;

$html['css']['snippet_forum_format_js_css'] = <<<EOT
<style>
	#forum_toolbar select:disabled,#forum_toolbar .disabled {
		opacity:0.5;
		cursor: not-allowed;
	}
	#_tryitEditor_contents .onethird-forum .item {
		border:1px dotted #CB0F00;
	}
	#_tryitEditor_contents .onethird-forum .item select
	,#_tryitEditor_contents .onethird-forum .item input {
		margin: 2px;
	}
	#_tryitEditor_contents .onethird-forum .item-panel .handle {
		position: absolute;
		top:3px;
		right:3px;
	}
	#_tryitEditor_contents .onethird-forum .item-panel .handle img {
		width:18px;
		margin-left:7px;
		cursor:pointer;
	}
	
</style>
EOT;

$html['meta']['snippet_forum_format_js_css'] = <<<EOT
<script>
	\$(function(){
		ot.editor = ot.editor || {};
		ot.editor.hide_ind = true;
		ot.editor.onready = function() {
			\$('#_tryitEditor_contents .onethird-forum .item').attr('contenteditable','false').each(function(){
				var o = \$(this);
				var h = '';
				h += ot.inpage_write_forum_select_str(o.attr('data-type'));
				h += "<input type='text' value='"+o.attr('data-name')+"' />";
				o.html(h);
			});
			ot.adj_forum_hnd();
			if (!ot.tryitEditor.org_html) {
				ot.tryitEditor.org_html = ot.tryitEditor.html;
				ot.tryitEditor.html = function(a) {
					\$("#_tryitEditor_contents .onethird-forum .handle").remove();
					\$("#_tryitEditor_contents .onethird-forum .item").each(function(){
						var o = \$(this);
						try {
							var t = o.find('select').val();
							o.attr('data-type',t);
							t = o.find('input').val();
							o.attr('data-name',t);
						} catch (e) {
						}
					});
					\$("#_tryitEditor_contents .onethird-forum select").remove();
					\$("#_tryitEditor_contents .onethird-forum input").remove();
					\$("#_tryitEditor_contents .onethird-forum .item").removeAttr('contenteditable');
					
					return ot.tryitEditor.org_html(a);
				}
			}
		}
		ot.inpage_write_forum_select_str = function(x){
			var h = '';
			var ar = ['img','text','select','date','number','time','radio','checkbox','html','Title','Contents','Date','tel','map','url','Tag'];
			h += "<select>";
			for (var i=0; i < ar.length; ++i) {
				var v = ar[i];
				h += "<option value='"+v+"' ";
				if (v == x) {
					h += " selected ";
				}
				h += ">"+v+"</option>";
			}
			h += "</select>";
			return h;
		};
		ot.adj_forum_hnd = function(o){
			if (!o) {
				o = "#_tryitEditor_contents .onethird-forum .item-panel ";
			}
			\$(o).append("<span class='handle'>{$ut->icon('add'," onclick='ot.forum_add(this)' ")}{$ut->icon('remove'," onclick='ot.forum_del(this)' ")}{$ut->icon('up'," onclick='ot.forum_up(this)' ")}{$ut->icon('dn'," onclick='ot.forum_dn(this)' ")}</span>");
		};
		ot.forum_add = function(obj){
			var o = obj.parentElement.parentElement.outerHTML;
			o = \$(o);
			o.find('span.handle').remove();
			ot.adj_forum_hnd(o);
			\$(obj).parents('.item-panel').after(o);
		};
		ot.forum_del = function(obj){
			\$(obj).parents('.item-panel').remove();
		};
		ot.forum_up = function(obj){
			var o = \$(obj).parents('.item-panel');
			var x = o.prev();
			if (x.length) {
				x.before(o);
			}
		};
		ot.forum_dn = function(obj){
			var o = \$(obj).parents('.item-panel');
			var x = o.next();
			if (x != o) {
				x.after(o);
			}
		};
	});
	
</script>
EOT;

}

function check_forum_item_owner($m)
{
	global $ut;
	if (check_rights()) {
		if ($ut->page('user') && (check_rights('owner') || $ut->page('user') == $_SESSION['login_id'])) {
			return true;
		}
	}
	if (!empty($m['ezlogin_id']) && !empty($_SESSION['ezlogin_id']) && $m['ezlogin_id'] == $_SESSION['ezlogin_id']) {
		return true;
	}
	return false;
}

function check_and_set_forum_rights()
{
	$r = check_rights() || !empty($_SESSION['ezlogin_id']);
	
	if (!$r) {
		return false;
	}
	if (!check_func_rights('add_page')) {
		set_func_rights('edit.modules',false);
		set_func_rights('add_page',false);
		provide_edit_rights();
		provide_edit_module();
	}
	return true;
}

function check_forum_draft(&$page_ar)
{
	if (empty($page_ar['meta'])) {
		return true;
	}
	if (empty($page_ar['meta']['plugin_embed']['status'])) {
		return true;
	}
	return false;
}

function get_forum_avatar(&$page_ar)
{
	global $config,$ut,$database;
	
	$img = $config['site_ssl']."img/personal.png";
	$name = '';
	if ($page_ar['user']) {
		$name = get_user_name($page_ar['user']);
		$img = get_user_image($page_ar['user']);
	}

	if (!empty($page_ar['meta']['ezlogin_id'])) {
		$sql = array();
		$sql[0] = "select id,metadata,status from ".DBX."user_log";
		$sql[1] = array(" where id=?",(int)$page_ar['meta']['ezlogin_id']);
		$ar = $database->sql_select_all($sql);
		if ($ar) {
			$m = unserialize64($ar[0]['metadata']);
			if (!empty($m['avatar'])) {
				$img = $ut->image_url('avatar/'.$m['avatar']);
			}
			if (!empty($m['ez_name'])) {
				$name = $m['ez_name'];
			}
		}
	}
	
	return "<div class='avatar'><img src='$img' alt='avatar'  /> $name </div>";
	
}

function forum_embed_onbefore_modified( &$new_ar )
{
	global $params;
	$status_new = (!empty($new_ar['meta']['plugin_embed']['status'])) ? $new_ar['meta']['plugin_embed']['status'] : 0;
	$status_old = (!empty($params['inner_page']['meta']['plugin_embed']['status'])) ? $params['inner_page']['meta']['plugin_embed']['status'] : 0;
	
	$ar = $new_ar;
	if ($new_ar['block_type'] == 5) {
		if (!read_pagedata( $new_ar['link'], $ar )) {
			echo('error');
			die();
		}
		if ($status_new != $status_old) {
			if (isset($new_ar['meta']['plugin_embed']['status'])) {
				if ($new_ar['meta']['plugin_embed']['status']=='Close') {
					// close
				}
			}
		}
	} else {
	}
	$ar['mod_date'] = $params['now'];
	mod_data_items($ar);

}


?>